<?php
/**
 * WRITE SOMETHING ABOUT THIS CLASS
 *
 * @package admin
 */

namespace ld_video_resume_ns {

    /**
     * Class to handle ___
     */
    class video_resume_setting
    {
        /**
         * Instance of this class.
         *
         * @since    1.0.0
         *
         * @var object
         */
        protected static $instance = null;

        /**
         * Initialization.
         */
        public function __construct() {
            add_filter( 'learndash_settings_fields' , array( $this, 'video_resume_setting' ) ,10 , 2 );
            // add_action( 'add_meta_boxes', array( $this, 'add_meta_box' ) );
            add_action( 'save_post_sfwd-lessons', array( $this, 'save_video_resume_setting' ) );
            add_action( 'save_post_sfwd-topic', array( $this, 'save_video_resume_setting' ) );
        }

        /**
         * Returns an instance of this class.
         *
         * @since     1.0.0
         *
         * @return object A single instance of this class.
         */
        public static function get_instance() {
            // If the single instance hasn't been set, set it now.
            if (null == self::$instance) {
                self::$instance = new self();
            }

            return self::$instance;
        }

        public function save_video_resume_setting( $post_id ){

            // Bail if we're doing an auto save
            if( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return;

            // if our nonce isn't there, or we can't verify it, bail
            if( ! isset( $_POST['video_resume_provider_nonce'] ) || ! wp_verify_nonce( $_POST['video_resume_provider_nonce'], 'video_resume_provider_action' ) ){
                return;
            }

            if( isset( $_POST['video_resume_provider'] ) ) {
                update_post_meta( $post_id, 'video_resume_provider', sanitize_text_field( $_POST['video_resume_provider'] ) );
            }
        }
        public function video_resume_setting( $setting_option_fields , $settings_metabox_key ){

            $allowed_in_setting = array(
                'learndash-lesson-display-content-settings',
                'learndash-topic-display-content-settings',
            );

            if ( ! in_array( $settings_metabox_key, $allowed_in_setting ) ) {
                return $setting_option_fields;
            }

            $post_id = '';
            if ( isset( $_GET['post'] ) ) {
                $post_id = intval($_GET['post']);
            }

            $video_resume_provider = get_post_meta( $post_id, 'video_resume_provider', true ); //Write a code to set a default value.;

            // return $setting_option_fields;
            $pos = array_search( 'lesson_video_track_time', array_keys( $setting_option_fields ) );

            if ( empty( $pos ) ) {
                return $setting_option_fields;
            }

            $setting_option_field = array();

            $select_html = '<select name="video_resume_provider" id ="learndash-lesson-display-content-settings_video_resume_provider">';
            $initial_options = array(
                ''     => __( 'Select Video Provider', 'ld_video_resume' ),
                'vimeo' => __( 'Vimeo', 'ld_video_resume' ),
                'youtube' => __( 'Youtube', 'ld_video_resume' ),
                'wistia' => __( 'Wistia', 'ld_video_resume' ),

            );

            foreach ($initial_options as $key => $value) {
                $select_html .= '<option value="'. $key .'" '.selected( $key, $video_resume_provider, false ).'>'. esc_html( $value ) .'</option>';
            }


            $coming_soon = array(
                'jwplayer' => __( 'JWPlayer (Javascript Only)', 'ld_video_resume' ),
                'vooplayer' => __( 'VooPlayer', 'ld_video_resume' ),
                // 'local' => __( 'Local Player', 'ld_video_resume' ),
            );

            foreach ($coming_soon as $key => $value) {
                $select_html .= '<option value="'. $key .'" disabled>'. esc_html( $value ) .'</option>';
            }

            // $select_html.='</select>';
            $select_html.='</select>'.wp_nonce_field( 'video_resume_provider_action', 'video_resume_provider_nonce',true,false );

            $setting_option_field['video_resume_provider'] = array(
                'name'           => 'video_resume_provider',
                'label'          => __( 'Multiple Video Resume Support ', 'ld_video_resume' ),
                'type'           => 'html',
                'value'           => $select_html,
                'help_text'      => __( 'Please select video provider to work with .', 'ld_video_resume' ),
                // 'parent_setting' => 'lesson_video_enabled',
            );


            // $setting_option_field['video_resume_provider'] = array(
            //     'name'           => 'video_resume_provider',
            //     'label'          => __( 'Video Provider', 'ld_video_resume' ),
            //     'type'           => 'select',
            //     'initial_options' => array(
            //                     '0' => __( 'Select video provider', 'ld_video_resume' ),
            //                     'vimeo' => __( 'Vimeo', 'ld_video_resume' ),
            //                     'wistia' => __( 'Wistia', 'ld_video_resume' ),
            //                     'JWPlayer' => __( 'JWPlayer', 'ld_video_resume' ),
            //                     'local' => __( 'Local Player', 'ld_video_resume' ),
            //                 ),
            //     'default'         => 'ANY',
            //     'help_text'      => __( 'Please select video provider to work with .', 'ld_video_resume' ),
            //     'show_in_rest'    => false,
            //     'parent_setting' => 'lesson_video_enabled',
            // );

            $setting_option_fields = array_merge(
                array_slice($setting_option_fields, 0, $pos+1),
                $setting_option_field,
                array_slice($setting_option_fields, $pos+1)
            );

            // error_log("\n[". date("Y-m-d H:i:s"). "] : pos = ".print_r( $pos, 1), 3, plugin_dir_path(__FILE__).'error.log');
            // error_log("\n[". date("Y-m-d H:i:s"). "] : settings_metabox_key = ".print_r( $settings_metabox_key, 1), 3, plugin_dir_path(__FILE__).'error.log');
            // error_log("\n[". date("Y-m-d H:i:s"). "] : setting_option_fields = ".print_r( $setting_option_fields, 1), 3, plugin_dir_path(__FILE__).'error.log');

            return $setting_option_fields;
        }

    }
    video_resume_setting::get_instance();
}
