<?php
/**
 * WRITE SOMETHING ABOUT THIS CLASS
 *
 * @package admin
 */

namespace ld_video_resume_ns {

    /**
     * Class to handle ___
     */
    class video_resume
    {
        /**
         * Instance of this class.
         *
         * @since    1.0.0
         *
         * @var object
         */
        protected static $instance = null;

        /**
         * Initialization.
         */
        public function __construct() {
            add_action ( 'learndash-lesson-after', array( $this ,'enqueue_js' ) );
            add_action ( 'learndash-topic-after', array( $this ,'enqueue_js' ) );
            add_filter( 'embed_oembed_html' , array($this , 'adding_wistia_class'), 10,5);
        }

        /**
         * Returns an instance of this class.
         *
         * @since     1.0.0
         *
         * @return object A single instance of this class.
         */
        public static function get_instance() {
            // If the single instance hasn't been set, set it now.
            if (null == self::$instance) {
                self::$instance = new self();
            }

            return self::$instance;
        }

        public function adding_wistia_class($cache, $url, $attr, $post_ID ){

            $video_provider = get_post_meta( $post_ID, 'video_resume_provider', true ); //Write a code to set a default value.;
            if ( empty( $video_provider ) ) {
                return $cache;
            }
            if ( ( strpos( $cache, 'wistia.com' ) !== false ) || ( strpos( $cache, 'wistia.net' ) !== false ) ) {
                $cache = str_replace( 'wp-embedded-content', 'wp-embedded-content wistia_embed', $cache );
            }elseif (( strpos( $cache, 'youtube.com' ) !== false )){
                $cache = str_replace( '?feature=oembed', '?feature=oembed&enablejsapi=1', $cache );
            }
            return $cache;
        }

        public function enqueue_js(){
            global $post;
            
            if( empty( $post ) ){
                return;
            }
            if ( ! isset( $post->post_type ) || ! in_array($post->post_type, array( 'sfwd-lessons', 'sfwd-topic' ) ) ) {
                return;
            }

            // if ( 'on' != learndash_get_setting( $post, 'lesson_video_track_time') ) {
            //     return;
            // }
            $video_provider = get_post_meta( $post->ID, 'video_resume_provider', true ); //Write a code to set a default value.;
            if ( empty( $video_provider ) ) {
                return;
            }
            $user_id = 0;
            if ( is_user_logged_in() ) {
                $user_id = get_current_user_id();
            }
            $dependency = array('jquery');
            $youtube_enabled = false;
            if ( 'vimeo' == $video_provider) {
                wp_enqueue_script( 'vimeo_iframe_api', 'https://player.vimeo.com/api/player.js', array( 'jquery' ), LD_VIDEO_RESUME_VERSION, true );
                $dependency[] = 'vimeo_iframe_api';
            }elseif ( 'youtube' == $video_provider) {
                wp_enqueue_script( 'youtube_iframe_api', 'https://www.youtube.com/iframe_api', array( 'jquery' ), LD_VIDEO_RESUME_VERSION, true );
                $dependency[] = 'youtube_iframe_api';
                $setting = learndash_get_setting( $post, 'lesson_video_track_time' );
                if ( ! empty( $setting ) ) {
                    $youtube_enabled = true;
                }
            }elseif ( 'wistia' == $video_provider) {
                wp_enqueue_script( 'wistia_iframe_api', '//fast.wistia.com/assets/external/E-v1.js', array( 'jquery' ), LD_VIDEO_RESUME_VERSION, true );
                $dependency[] = 'wistia_iframe_api';
            }

            $min = '';

            if ( ! LD_VIDEO_RESUME_DEBUG ) {
                $min = '.min';
            }

            wp_enqueue_script( 'video_resume_js', plugins_url( "js/{$video_provider}/player-handler{$min}.js", __FILE__ ), $dependency, LD_VIDEO_RESUME_VERSION, true);

            $per = 0;
            $ajax_nonce = wp_create_nonce('nonce-video-resume');
            $data_array = array(
                'ajax_url' => admin_url('admin-ajax.php'),
                'action' => 'ms_video_resume',
                'nonce' => $ajax_nonce,
                'post_id' => $post->ID,
                'cookie_name' => 'video_resume_'.preg_replace("/[^0-9a-zA-Z_-]+/", '_', base64_encode($user_id)).'_',
                'youtube_enabled' => $youtube_enabled,
            );
            wp_localize_script( 'video_resume_js', 'video_resume_obj', $data_array );
        }

    }
    video_resume::get_instance();
}
