jQuery(document).ready(function(){

	if ( typeof Vimeo != "undefined" ) {
		ms_video_handler();
	}

	function ms_video_handler(){

		var all_videos = jQuery('iframe');

		all_videos.each(function(){
			try{
				var player = new Vimeo.Player(jQuery(this));
				/* Setting last watched */
				player.getVideoId().then(function(id) {
					var latest_seconds = ms_readCookie( video_resume_obj.cookie_name+id );
					if (latest_seconds) {
						player.setCurrentTime(latest_seconds);
					}
				}).catch(function(error) {
				    /* an error occurred */
				});

				/* Updating seconds in cookie */
				player.on('timeupdate', function(data){
					player.getVideoId().then(function(id) {
					    ms_createCookie(video_resume_obj.cookie_name+id,data.seconds,365);
					}).catch(function(error) {
					    /*an error occurred*/
					});

				});
				player.on('ended', function(data){
					player.getVideoId().then(function(id) {
					    ms_eraseCookie(video_resume_obj.cookie_name+id);
					}).catch(function(error) {
					    /*an error occurred*/
					});

				});

			} catch( err ){
				console.log(err);
			}
		});
	} /*function end*/
});



function ms_createCookie(name,value,days) {
    if (days) {
        var date = new Date();
        date.setTime(date.getTime() + (days * 24 * 60 * 60 *1000));
        var expires = "; expires=" + date.toGMTString();
    } else {
        var expires = "";
    }
    document.cookie = name + "=" + value + expires + "; path=/";
}

function ms_readCookie(name) {
    var nameEQ = name + "=";
    var ca = document.cookie.split(';');
    for(var i=0;i < ca.length;i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') {
            c = c.substring(1,c.length);
        }
        if (c.indexOf(nameEQ) == 0) {
            return c.substring(nameEQ.length,c.length);
        }
    }
    return null;
}

function ms_eraseCookie(name) {
    ms_createCookie(name,"",-1);
}
